SystemOrganization addCategory: #ConfigurationOfCodeTalk!

Object subclass: #ConfigurationOfCodeTalk
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCodeTalk'!

!ConfigurationOfCodeTalk class methodsFor: 'development support' stamp: 'DaleHenrichs 12/17/2010 10:23'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCodeTalk class methodsFor: 'private' stamp: 'DaleHenrichs 11/2/2010 16:51'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCodeTalk class methodsFor: 'private' stamp: 'DaleHenrichs 12/6/2010 13:34'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCodeTalk class methodsFor: 'private' stamp: 'DaleHenrichs 11/4/2010 10:23'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCodeTalk class methodsFor: 'metacello tool support' stamp: 'DaleHenrichs 11/2/2010 14:58'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCodeTalk class methodsFor: 'loading' stamp: 'DaleHenrichs 11/29/2010 15:00'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCodeTalk class methodsFor: 'loading' stamp: 'DaleHenrichs 11/29/2010 15:00'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCodeTalk class methodsFor: 'loading' stamp: 'DaleHenrichs 11/29/2010 15:00'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCodeTalk class methodsFor: 'accessing' stamp: 'dkh 10/13/2009 10:36'!
project

	^self new project! !

!ConfigurationOfCodeTalk class methodsFor: 'development support' stamp: 'DaleHenrichs 1/13/2011 15:37'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCodeTalk methodsFor: 'baselines' stamp: 'mt 11/30/2010 18:36:13.428'!
baseline100: spec 
	<version: '1.0-baseline'>
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/codetalk'.
		spec project: 'OmniBrowser' with: [
			spec
				className: 'ConfigurationOfOmniBrowser';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.2';
				loads: #( Dev )].
		
		spec project: 'SwaUtil' with: [
			spec
				className: 'ConfigurationOfSwaUtil';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository';
				versionString: '1.0.1'].
		
		spec
			package: 'CodeTalk' with: [ spec requires: #('OmniBrowser' 'SwaUtil') ];
			package: 'CT-Monticello';
			package: 'CT-MarkupBrowser';
			group: 'default' with: #('CodeTalk' 'CT-Monticello' 'CT-MarkupBrowser'). ].! !

!ConfigurationOfCodeTalk methodsFor: 'baselines' stamp: 'mt 11/30/2010 18:35:46.712'!
baselineHead: spec 
	<version: 'head-baseline'>
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/codetalk'.
		spec project: 'OmniBrowser' with: [
			spec
				className: 'ConfigurationOfOmniBrowser';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.2';
				loads: #( Dev )].
		
		spec project: 'SwaUtil' with: [
			spec
				className: 'ConfigurationOfSwaUtil';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository';
				versionString: 'head'].
		spec
			package: 'SWAOBExtensions' with: [spec
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'].
			
		spec
			package: 'CodeTalk' with: [ spec requires: #('OmniBrowser' 'SwaUtil' 'SWAOBExtensions') ];
			package: 'CT-Monticello';
			package: 'CT-MarkupBrowser';
			group: 'default' with: #('CodeTalk' 'CT-Monticello' 'CT-MarkupBrowser'). ].! !

!ConfigurationOfCodeTalk methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 13:54'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCodeTalk methodsFor: 'versions' stamp: 'mt 2/5/2011 17:29:20.426'!
version100: spec 

	<version: '1.0' imports: #('1.0-baseline') >
        
	spec for: #common do: [
		spec blessing: #stable.
		spec
			package: 'CodeTalk' with: 'CodeTalk-mt.30';
			package: 'CT-Monticello' with: 'CT-Monticello-mt.4';
			package: 'CT-MarkupBrowser' with: 'CT-MarkupBrowser-mt.4'].! !

!ConfigurationOfCodeTalk methodsFor: 'versions' stamp: 'mt 11/30/2010 18:35:23.257'!
versionHead: spec 

	<version: 'head' imports: #('head-baseline') >
 
	spec for: #common do: [spec blessing: #development].! !
